| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Member Functions | Private Attributes | List of all members
ChronoAuditor Class Reference

Monitors the cpu time usage of each algorithm. More...

`#include <src/ChronoAuditor.h>`

Inheritance diagram for ChronoAuditor:
[legend]
Collaboration diagram for ChronoAuditor:
[legend]

## Public Member Functions
| ChronoAuditor (const std::string &name, ISvcLocator *pSvcLocator)
| ~ChronoAuditor () override=default
StatusCode | initialize () override
Public Member Functions inherited from CommonAuditor
| CommonAuditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
virtual | ~CommonAuditor ()=default
| Destructor. More...
virtual void | before (StandardEventType evt, const std::string &caller)
virtual void | before (StandardEventType evt, INamedInterface *caller)
virtual void | before (CustomEventTypeRef evt, const std::string &caller)
virtual void | before (CustomEventTypeRef evt, INamedInterface *caller)
virtual void | after (StandardEventType evt, const std::string &caller, const StatusCode &sc)
virtual void | after (StandardEventType evt, INamedInterface *caller, const StatusCode &sc)
virtual void | after (CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc)
virtual void | after (CustomEventTypeRef evt, INamedInterface *caller, const StatusCode &sc)
Public Member Functions inherited from Auditor
| Auditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
| ~Auditor () override=default
| Destructor. More...
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysFinalize () override
| Finalization method invoked by the framework. More...
void | before (StandardEventType, INamedInterface *) override
| The following methods are meant to be implemented by the child class... More...
void | before (StandardEventType, const std::string &) override
void | before (CustomEventTypeRef, INamedInterface *) override
void | before (CustomEventTypeRef, const std::string &) override
void | after (StandardEventType, INamedInterface *, const StatusCode &) override
void | after (StandardEventType, const std::string &, const StatusCode &) override
void | after (CustomEventTypeRef, INamedInterface *, const StatusCode &) override
void | after (CustomEventTypeRef, const std::string &, const StatusCode &) override
void | beforeInitialize (INamedInterface *) override
void | afterInitialize (INamedInterface *) override
void | beforeReinitialize (INamedInterface *) override
void | afterReinitialize (INamedInterface *) override
void | beforeExecute (INamedInterface *) override
void | afterExecute (INamedInterface *, const StatusCode &) override
void | beforeFinalize (INamedInterface *) override
void | afterFinalize (INamedInterface *) override
void | beforeBeginRun (INamedInterface *) override
void | afterBeginRun (INamedInterface *) override
void | beforeEndRun (INamedInterface *) override
void | afterEndRun (INamedInterface *) override
virtual StatusCode | finalize ()
const std::string & | name () const override
bool | isEnabled () const override
SmartIF< ISvcLocator > & | serviceLocator () const
| The standard service locator. More...
template<class T >
StatusCode | service (const std::string &name, T *&svc, bool createIf=false) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T = IService>
SmartIF< T > | service (const std::string &name, bool createIf=false) const
StatusCode | setProperty (const Property &p) override
| Set a value of a property of an auditor. More...
StatusCode | setProperty (const std::string &s) override
| Implementation of IProperty::setProperty. More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| Implementation of IProperty::setProperty. More...
StatusCode | getProperty (Property *p) const override
| Get the value of a property. More...
const Property & | getProperty (const std::string &name) const override
| Get the property by name. More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| Implementation of IProperty::getProperty. More...
const std::vector< Property * > & | getProperties () const override
| Get all properties. More...
bool | hasProperty (const std::string &name) const override
| Implementation of IProperty::hasProperty. More...
template<class TYPE >
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | setProperties ()
| Set the auditor's properties. More...
template<class T >
Property * | declareProperty (const std::string &name, T &property, const std::string &doc="none") const
| Declare the named property. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...

## Private Member Functions
void | i_before (CustomEventTypeRef evt, const std::string &caller) override
| Default (catch-all) "before" Auditor hook. More...
void | i_after (CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc) override
| Default (catch-all) "after" Auditor hook. More...
std::string | i_id (CustomEventTypeRef evt, const std::string &caller)
| Compute the id string to be used for the chrono entity. More...
SmartIF< IChronoStatSvc > & | chronoSvc ()

## Private Attributes
SmartIF< IChronoStatSvc > | m_chronoSvc

## Additional Inherited Members
Public Types inherited from Auditor
typedef Gaudi::PluginService::Factory< IAuditor *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from CommonMessaging< implements< IAuditor, IProperty > >
using | base_class = CommonMessaging
Protected Member Functions inherited from CommonAuditor
bool | i_auditEventType (const std::string &evt)
| Check if we are requested to audit the passed event type. More...
void | i_updateCustomTypes (Property &)
| Update handler for the obsolete property CustomEventTypes. More...
Protected Member Functions inherited from CommonMessaging< implements< IAuditor, IProperty > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from CommonAuditor
StringArrayProperty | m_types
StringArrayProperty | m_customTypes

## Detailed Description

Monitors the cpu time usage of each algorithm.

Author
  David Quarrie
  Marco Clemencic

Definition at line 14 of file ChronoAuditor.h.

## Constructor & Destructor Documentation

ChronoAuditor::ChronoAuditor | ( | const std::string & | name,
|  | ISvcLocator * | pSvcLocator
| ) |  |

Definition at line 14 of file ChronoAuditor.cpp.

15 : CommonAuditor(name, pSvcLocator) {
16 }
CommonAuditor::CommonAuditor
CommonAuditor(const std::string &name, ISvcLocator *svcloc)
Constructor.
Definition: CommonAuditor.cpp:3

ChronoAuditor::~ChronoAuditor | ( |  | ) |
| override default

## Member Function Documentation

SmartIF<IChronoStatSvc>& ChronoAuditor::chronoSvc | ( |  | ) |
| inline private

Definition at line 34 of file ChronoAuditor.h.

34 { return m_chronoSvc; }
ChronoAuditor::m_chronoSvc
SmartIF< IChronoStatSvc > m_chronoSvc
Definition: ChronoAuditor.h:35

void ChronoAuditor::i_after | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller,
|  | const StatusCode & | sc
| ) |  |
| override private virtual

Default (catch-all) "after" Auditor hook.

Implements CommonAuditor.

Definition at line 35 of file ChronoAuditor.cpp.

36 {
37 chronoSvc()->chronoStop(i_id(evt, caller));
38 }
ChronoAuditor::chronoSvc
SmartIF< IChronoStatSvc > & chronoSvc()
Definition: ChronoAuditor.h:34
read_lhcb_event_file.evt
tuple evt
Definition: read_lhcb_event_file.py:14
ChronoAuditor::i_id
std::string i_id(CustomEventTypeRef evt, const std::string &caller)
Compute the id string to be used for the chrono entity.
Definition: ChronoAuditor.h:30

void ChronoAuditor::i_before | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller
| ) |  |
| override private virtual

Default (catch-all) "before" Auditor hook.

Implements CommonAuditor.

Definition at line 30 of file ChronoAuditor.cpp.

31 {
32 chronoSvc()->chronoStart(i_id(evt, caller));
33 }
ChronoAuditor::chronoSvc
SmartIF< IChronoStatSvc > & chronoSvc()
Definition: ChronoAuditor.h:34
read_lhcb_event_file.evt
tuple evt
Definition: read_lhcb_event_file.py:14
ChronoAuditor::i_id
std::string i_id(CustomEventTypeRef evt, const std::string &caller)
Compute the id string to be used for the chrono entity.
Definition: ChronoAuditor.h:30

std::string ChronoAuditor::i_id | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller
| ) |  |
| inline private

Compute the id string to be used for the chrono entity.

Definition at line 30 of file ChronoAuditor.h.

30 {
31 return caller + ":" + evt;
32 }
read_lhcb_event_file.evt
tuple evt
Definition: read_lhcb_event_file.py:14

StatusCode ChronoAuditor::initialize | ( |  | ) |
| override virtual

Reimplemented from Auditor.

Definition at line 18 of file ChronoAuditor.cpp.

18 {
19 StatusCode sc = CommonAuditor::initialize();
20 if (UNLIKELY(sc.isFailure())) return sc;
21
22 m_chronoSvc = serviceLocator()->service("ChronoStatSvc");
23 if (UNLIKELY(!m_chronoSvc.get())) {
24 error() << "Cannot get ChronoStatSvc" << endmsg;
25 return StatusCode::FAILURE;
26 }
27 return StatusCode::SUCCESS;
28 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:126
merge_files.sc
int sc
Definition: merge_files.py:167
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:86
SmartIF::get
TYPE * get() const
Get interface pointer.
Definition: SmartIF.h:76
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:78
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:118
StatusCode::FAILURE
Definition: StatusCode.h:29
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
ChronoAuditor::m_chronoSvc
SmartIF< IChronoStatSvc > m_chronoSvc
Definition: ChronoAuditor.h:35
Auditor::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const
The standard service locator.
Definition: Auditor.cpp:211
Auditor::initialize
virtual StatusCode initialize()
Definition: Auditor.cpp:82
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

## Member Data Documentation

SmartIF<IChronoStatSvc> ChronoAuditor::m_chronoSvc
| private

Definition at line 35 of file ChronoAuditor.h.

The documentation for this class was generated from the following files:

- GaudiAud/src/ChronoAuditor.h
- GaudiAud/src/ChronoAuditor.cpp